;;;; Elm mode configuration.
(use-package elm-mode
    :ensure t
    :bind
    ("M-<tab>" . company-indent-or-complete-common)
    :config
    (use-package lsp-mode)
    (use-package lsp-ui)
    (use-package company)
    (setq elm-format-on-save t
          elm-tags-on-save t
          elm-tags-exclude-elm-stuff nil)
    (add-to-list 'company-backends 'company-elm)
    (add-to-list 'auto-mode-alist '("\\.elm\\'" . elm-mode))
    :hook
    (after-init . global-flycheck-mode)
    (elm-mode   . company-mode)
    (elm-mode   . lsp)
    (elm-mode   . (lambda () (setq evil-auto-indent nil))))

(with-eval-after-load 'flycheck
      '(add-hook 'flycheck-mode-hook #'flycheck-elm-setup))

(provide 'jenga-elm)
